> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Shopping List

POST https://api-b2b.bigcommerce.com/api/v3/io/shopping-list
Content-Type: application/json

Create a shopping list for a user

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/b2b/management/shopping-list/post-shopping-list

## Authentication

- `X-Auth-Token` header (required) — | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts). | For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).
- `X-Store-Hash` header (required) — | Header | Argument | Description | |:-------|:---------|:------------| | `X-Store-Hash` | `store_hash` | The unique store hash associated with a BigCommerce store that has B2B Edition enabled. |

## Request

### Body (application/json)

This endpoint expects an object.

- `name` (string, required)
- `description` (string, optional) — Description information for shopping list
- `status` (enum, optional) — status of shopping list, (0: approved, 20: deleted, 30: draft, 40: ready for approval)
  - Allowed values: `0`, `30`, `40`
- `userId` (integer, optional) — B2B Edition buyer user ID (one of userId and customerId must be passed, and only one of them can be passed).
- `customerId` (integer, optional) — BigCommerce customer ID(one of userId and customerId must be passed, and only one of them can be passed).
- `channelId` (integer, optional) — BigCommerce channel ID
- `items` (list of shopping_list_item, optional)

## Response

### 200

OK

- `code` (integer, optional) — Response code of success request.
- `meta` (ShoppingListPostResponsesContentApplicationJsonSchemaMeta, optional)
- `data` (ShoppingListPostResponsesContentApplicationJsonSchemaData, optional)

## Errors

### 422 Unprocessable Entity Error

Parameter Error

- `code` (double, required) — response status code
- `data` (ShoppingListPostResponsesContentApplicationJsonSchemaData, required)
- `meta` (ShoppingListPostResponsesContentApplicationJsonSchemaMeta, required)

## Types

### shopping_list_item

Shopping List Items

- `productId` (integer, required) — product ID for shopping list item
- `variantId` (integer, required) — Variant ID for shopping list item. If the product has options, variant ID is required, otherwise it can be left blank.
- `quantity` (integer, required) — Quantity of product and variant
- `id` (integer, optional) — unique ID field for shopping list item
- `sortOrder` (integer, optional) — The sort order for item
- `optionList` (ShoppingListItemOptionList, optional) — The optionlist does not need to be entered and will be automatically obtained based on productId and variantId.
- `productNote` (string, optional) — product note

### ShoppingListPostResponsesContentApplicationJsonSchemaMeta

- `message` (string, required) — error information

### ShoppingListPostResponsesContentApplicationJsonSchemaData

- `errMsg` (ShoppingListPostResponsesContentApplicationJsonSchemaDataErrMsg, required) — Error detail information for some parameters.

### ShoppingListItemOptionList

The optionlist does not need to be entered and will be automatically obtained based on productId and variantId.

- `optionId` (string, optional)
- `optionValue` (string, optional)

### ShoppingListPostResponsesContentApplicationJsonSchemaDataErrMsg

Error detail information for some parameters.

## Examples

**Request**

```json
{
  "name": "my first shopping list",
  "description": "this is my first shopping list",
  "status": 0,
  "userId": 0,
  "channelId": 1,
  "items": [
    {
      "productId": 123,
      "variantId": 321,
      "quantity": 5
    }
  ]
}
```

**Response**

```json
{
  "code": 200,
  "meta": {
    "message": "SUCCESS"
  },
  "data": {
    "shoppingListId": 1
  }
}
```

**SDK Code**

```python example-1
import requests

url = "https://api-b2b.bigcommerce.com/api/v3/io/shopping-list"

payload = {
    "name": "my first shopping list",
    "description": "this is my first shopping list",
    "status": 0,
    "userId": 0,
    "channelId": 1,
    "items": [
        {
            "productId": 123,
            "variantId": 321,
            "quantity": 5
        }
    ]
}
headers = {
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://api-b2b.bigcommerce.com/api/v3/io/shopping-list';
const options = {
  method: 'POST',
  headers: {'X-Auth-Token': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"name":"my first shopping list","description":"this is my first shopping list","status":0,"userId":0,"channelId":1,"items":[{"productId":123,"variantId":321,"quantity":5}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api-b2b.bigcommerce.com/api/v3/io/shopping-list"

	payload := strings.NewReader("{\n  \"name\": \"my first shopping list\",\n  \"description\": \"this is my first shopping list\",\n  \"status\": 0,\n  \"userId\": 0,\n  \"channelId\": 1,\n  \"items\": [\n    {\n      \"productId\": 123,\n      \"variantId\": 321,\n      \"quantity\": 5\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://api-b2b.bigcommerce.com/api/v3/io/shopping-list")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"my first shopping list\",\n  \"description\": \"this is my first shopping list\",\n  \"status\": 0,\n  \"userId\": 0,\n  \"channelId\": 1,\n  \"items\": [\n    {\n      \"productId\": 123,\n      \"variantId\": 321,\n      \"quantity\": 5\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api-b2b.bigcommerce.com/api/v3/io/shopping-list")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"my first shopping list\",\n  \"description\": \"this is my first shopping list\",\n  \"status\": 0,\n  \"userId\": 0,\n  \"channelId\": 1,\n  \"items\": [\n    {\n      \"productId\": 123,\n      \"variantId\": 321,\n      \"quantity\": 5\n    }\n  ]\n}")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api-b2b.bigcommerce.com/api/v3/io/shopping-list', [
  'body' => '{
  "name": "my first shopping list",
  "description": "this is my first shopping list",
  "status": 0,
  "userId": 0,
  "channelId": 1,
  "items": [
    {
      "productId": 123,
      "variantId": 321,
      "quantity": 5
    }
  ]
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://api-b2b.bigcommerce.com/api/v3/io/shopping-list");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"my first shopping list\",\n  \"description\": \"this is my first shopping list\",\n  \"status\": 0,\n  \"userId\": 0,\n  \"channelId\": 1,\n  \"items\": [\n    {\n      \"productId\": 123,\n      \"variantId\": 321,\n      \"quantity\": 5\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = [
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "my first shopping list",
  "description": "this is my first shopping list",
  "status": 0,
  "userId": 0,
  "channelId": 1,
  "items": [
    [
      "productId": 123,
      "variantId": 321,
      "quantity": 5
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api-b2b.bigcommerce.com/api/v3/io/shopping-list")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```